package com.javahonk;

import javax.jms.JMSException;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.AbstractApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.javahonk.solace.SolaceMessageProducer;


public class JavaHonkSolaceMessageTestApp {
	
	private static final Logger logger = LogManager.getLogger(JavaHonkSolaceMessageTestApp.class);

	public static void main(String[] args) throws JMSException, InterruptedException {
		
		logger.info("Solace messaging started...");
		
		ApplicationContext context = new ClassPathXmlApplicationContext("spring-context.xml");
		
		SolaceMessageProducer solaceMessageProducer = context.getBean(SolaceMessageProducer.class);
		
		for (int i = 0; i < 15; i++) {
			solaceMessageProducer.sendMessages();
			Thread.sleep(2000);
		}
		
		keepApplicationRunning();
		
		((AbstractApplicationContext) context).close();
	}

	private static void keepApplicationRunning() {
		
		Thread thread = new Thread(new Runnable() {

			@Override
			public void run() {
			}
		});

		while (!thread.isInterrupted()) {
		}
	}

}
