package com.javahonk;

import java.util.Hashtable;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.solacesystems.jms.SupportedProperty;

public class SolaceJMSPubihser {
	
	public static void main(String... args) throws JMSException, NamingException {
    	
		System.out.println("SolJMSHelloWorldPub initializing...");
        
        Hashtable<String, Object> env = new Hashtable<String, Object>();
        env.put(InitialContext.INITIAL_CONTEXT_FACTORY, "com.solacesystems.jndi.SolJNDIInitialContextFactory");
        env.put(InitialContext.PROVIDER_URL, "tcp://url:portnumber");
        env.put(SupportedProperty.SOLACE_JMS_VPN, "solace_vpn=vpn name");
        env.put(Context.SECURITY_PRINCIPAL, "user name");
        env.put(Context.SECURITY_CREDENTIALS, "password");
        
        InitialContext initialContext = new InitialContext(env);
        ConnectionFactory cf = (ConnectionFactory)initialContext.lookup("JMS Factory name");    	
    	Connection connection = cf.createConnection();

        Session session = connection.createSession(false, Session.AUTO_ACKNOWLEDGE);

        Destination destination = (Destination)initialContext.lookup("queue name");

        MessageProducer producer = session.createProducer(destination);

        TextMessage testMessage = session.createTextMessage("Java Honk Solace JMS Hello world!!!");
        
        System.out.printf("Connected. About to send message '%s' to topic '%s'...%n", testMessage.getText(), destination.toString());

        producer.send(testMessage);
		
		System.out.println("Message sent. Exiting.");

        connection.close();

        initialContext.close();
    }    
}
