package com.javahonk.solace;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageListener;
import javax.jms.TextMessage;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.jms.core.JmsTemplate;

public class SolaceMessageConsumer implements MessageListener {
	
	private static final Logger logger = LogManager.getLogger(SolaceMessageConsumer.class.getName());
	
	private JmsTemplate jmsTemplate;

	@Override
	public void onMessage(Message message) {
		
		try {
			
			logger.info("Received message on destination: {}", message.getJMSDestination().toString());
			
			if (message instanceof TextMessage) {
				
				TextMessage txtMsg = (TextMessage) message;
				logger.info("Received response {}", message);
				Object msgTextObj = txtMsg.getText();				
				logger.info(msgTextObj.toString());
			}
		} catch (JMSException ex) {
			throw new RuntimeException(ex);
		}

	}

	public JmsTemplate getJmsTemplate() {
		return jmsTemplate;
	}

	public void setJmsTemplate(JmsTemplate jmsTemplate) {
		this.jmsTemplate = jmsTemplate;
	}

}
