package com.javahonk.solace;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Session;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.springframework.jms.core.JmsTemplate;
import org.springframework.jms.core.MessageCreator;

public class SolaceMessageProducer {
	
	private static final Logger logger = LogManager.getLogger(SolaceMessageProducer.class.getName());
	
	private JmsTemplate jmsTemplate;

	public void sendMessages() throws JMSException {
		
		getJmsTemplate().send(new MessageCreator() {
			
			@Override
			public Message createMessage(Session session) throws JMSException {
				
				logger.info("Sending message...");
				Message message = session.createTextMessage("Java Honk sent message on Solace queue.");
				return message;
			}
		});		
	}

	public JmsTemplate getJmsTemplate() {
		return jmsTemplate;
	}

	public void setJmsTemplate(JmsTemplate jmsTemplate) {
		this.jmsTemplate = jmsTemplate;
	}
	
	
}
